// bsp6a.cpp : manuelle Aufteilung mit Threads, feste Angabe
#include "stdafx.h"

#include <omp.h>


double calc(int id, int start, int points)
{
	return start*points;
}

int _tmain(int argc, _TCHAR* argv[])
{
	const int MAX=1000;
	int id, numThreads, start, points;
	double x;
	int n=4;

	//omp_set_num_threads(8);  // statt num_threads(4)
	#pragma omp parallel private (id, numThreads)  num_threads(n) 
	{
		numThreads = omp_get_num_threads();
		id=omp_get_thread_num();
		points = MAX / numThreads;
		start = id * points;
		x = calc(id, start, points);
		printf("Thread id:%d  numThreads: %d start: %d, points: %d, x: %d\n", 
			  id, numThreads, start, points, x);
	}		

	printf("Ende\n");
	char ch[200];
	gets(ch);	

	return 0;
}

















// 	1. Alternative
// #pragma omp parallel private (id, numThreads)  num_threads(4) 
// start ist nun eine shared Variable
// Ausgabe kritisch

// 	2. Alternative, die bessere
// #pragma omp parallel private (start, id, numThreads)  num_threads(4) 
// nun klappt es auch mit der start Variablen


